Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## rdlc.rdl
Class Platform_Standard

    java.lang.Object
      rdlc.rdl.Declaration_Named
          rdlc.rdl.DynRoot_Standard
              rdlc.rdl.Platform_Standard

All Implemented Interfaces:
  Declaration, DynRoot, Expression, Platform

     class Platform_Standard

extends DynRoot_Standard
implements Platform

Standard platform declaration, contains I/O ports, links and instances. In addition a platform has some special fields for which it provides accessors: language, default link type and engine.

Version:
  $Revision: 1.15 $
Author:
  Greg Gibeling

Nested Class Summary
`static class` | `Platform_Standard.Specifier` Iterator of the miscellaneous specifications that are part of a platform.

Nested classes/interfaces inherited from interface rdlc.rdl.Expression
`Expression.Phase`

Field Summary
`protected java.lang.String` | `accurateLinkType` The default accurate link type for this platform.
`protected java.lang.String` | `engine` The engine for this platform.
`protected java.lang.String` | `fastLinkType` The default fast link type for this platform.
`protected java.lang.String` | `language` The language for this platform.
`protected Expression.Phase` | `resolved` A flag to prevent us from trying to resolve this platform twice.

Fields inherited from class rdlc.rdl.DynRoot_Standard
`instance, isLeaf, isRoot`

Fields inherited from class rdlc.rdl.Declaration_Named
`iName, namespace, rawStaticID`

Constructor Summary
`Platform_Standard()` Standard constructor for a platform being parsed in.
`Platform_Standard(Namespace _namespace)` Default constructor for a platform, used only when an identifier cannot be resolved.

Method Summary
`void` | `add(Field platformField)` Add a platform field to this platform.
`void` | `add(Pair<FileRange,java.lang.String> _literal, Log errorLog, Platform_Standard.Specifier _spec)` This method is used during parsing to specify the language, default link type and engine, all of which are simply strings.
`protected void` | `generatePortLists(PlatformInstance _platformInstance, java.util.HashSet<java.lang.String> _unconnected, java.util.HashSet<java.lang.String> _connected)` Generates the list of connected and unconnected ports for the given platform instance.
`java.lang.String` | `getAccurateLinkType()` Simple accessor.
`java.lang.String` | `getEngine()` Simple accessor.
`java.lang.String` | `getFastLinkType()` Simple accessor.
`java.lang.String` | `getLanguage()` Simple accessor.
`void` | `resolve(java.util.HashSet<Declaration> markSet, Log errorLog, Expression.Phase phase)` In addition to the standard identifier resolution routines, this method will perform all kinds of error checking related to what kinds of map fields are allowed in leaf and root maps.
`java.lang.String` | `toString()` Simple accessor.

Methods inherited from class rdlc.rdl.DynRoot_Standard
`getInstance, getLambdaName, getRequirements, isLeaf, isRoot, setNamespace, typeMatch`

Methods inherited from class rdlc.rdl.Declaration_Named
`getBase, getIdentifier, getNamedBase, getRawStaticID, getType, setRawStaticID`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface rdlc.rdl.DynRoot
`getInstance, isLeaf, isRoot`

Methods inherited from interface rdlc.rdl.Declaration
`getBase, getIdentifier, getLambdaName, getNamedBase, getType, setRawStaticID`

Methods inherited from interface rdlc.rdl.Expression
`getRequirements, setNamespace, typeMatch`

Field Detail

### resolved

    protected Expression.Phase resolved

  A flag to prevent us from trying to resolve this platform twice. Basically to save us a lot of potentially wasted cycles.

### language

    protected java.lang.String language

  The language for this platform.

### fastLinkType

    protected java.lang.String fastLinkType

  The default fast link type for this platform.

### accurateLinkType

    protected java.lang.String accurateLinkType

  The default accurate link type for this platform.

### engine

    protected java.lang.String engine

  The engine for this platform.

Constructor Detail

### Platform_Standard

    public Platform_Standard()

  Standard constructor for a platform being parsed in. Creates an empty instance.

### Platform_Standard

    public Platform_Standard(Namespace _namespace)

  Default constructor for a platform, used only when an identifier cannot be resolved.

  Parameters:
    `_namespace` - The namespace to create this default platform in.

Method Detail

### toString

    public java.lang.String toString()

  Simple accessor.

  Overrides:
    `toString` in class `Declaration_Named`
  Returns:
    A human readable representation of this map for debugging.

### add

    public void add(Field platformField)

  Add a platform field to this platform. This is used during parsing to add both instances and named fields. In addition this method tracks how many of certain fields are added to determine `DynRoot_Standard.isLeaf` and `DynRoot_Standard.isRoot`.

  Parameters:
    `platformField` - The platform field to be added to this platform.

### add

    public void add(Pair<FileRange,java.lang.String> _literal,
                    Log errorLog,
                    Platform_Standard.Specifier _spec)

  This method is used during parsing to specify the language, default link type and engine, all of which are simply strings.

  Parameters:
    `_literal` - The literal value of the property being specified.
    `errorLog` - A list of all the errors to be reported.
    `_spec` - Determines which property is being specified.

### resolve

    public void resolve(java.util.HashSet<Declaration> markSet,
                        Log errorLog,
                        Expression.Phase phase)

  In addition to the standard identifier resolution routines, this method will perform all kinds of error checking related to what kinds of map fields are allowed in leaf and root maps.

  Specified by:
    `resolve` in interface `Expression`
  Overrides:
    `resolve` in class `Declaration_Named`
  Parameters:
    `markSet` - Complete hash set of declarations on which the caller depends (including itself).
    `errorLog` - Log of errors to be reported to the user.
    `phase` - The phase of resolution to perform.
  See Also:
    `Expression.resolve(HashSet, Log, Phase)`

### generatePortLists

    protected void generatePortLists(PlatformInstance _platformInstance,
                                     java.util.HashSet<java.lang.String> _unconnected,
                                     java.util.HashSet<java.lang.String> _connected)

  Generates the list of connected and unconnected ports for the given platform instance. This is a recursive method so that all of the platform instances in the hierarchy are examined.

  Parameters:
    `_platformInstance` - The platform instance whose links and ports should be checked.
    `_unconnected` - Hash set of unconnected (actually ALL) ports.
    `_connected` - Hash set of connected ports.

### getLanguage

    public java.lang.String getLanguage()

  Description copied from interface: `Platform`
  Simple accessor.

  Specified by:
    `getLanguage` in interface `Platform`
  Returns:
    The language to be output for use on this platform
  See Also:
    `Platform.getLanguage()`

### getFastLinkType

    public java.lang.String getFastLinkType()

  Description copied from interface: `Platform`
  Simple accessor.

  Specified by:
    `getFastLinkType` in interface `Platform`
  Returns:
    The default fast link type for this platform.
  See Also:
    `Platform.getFastLinkType()`

### getAccurateLinkType

    public java.lang.String getAccurateLinkType()

  Description copied from interface: `Platform`
  Simple accessor.

  Specified by:
    `getAccurateLinkType` in interface `Platform`
  Returns:
    The default accurate link type for this platform.
  See Also:
    `Platform.getAccurateLinkType()`

### getEngine

    public java.lang.String getEngine()

  Description copied from interface: `Platform`
  Simple accessor.

  Specified by:
    `getEngine` in interface `Platform`
  Returns:
    The emulation engine to be used for this platform.
  See Also:
    `Platform.getEngine()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD